
#include <stdio.h>
#include <stdlib.h>

char	OutputFileName[20];
char	FileLine[20];
char	byte;
char * buffer;

int	CurrentFile;


int main(int argc, char *argv[])
{
	unsigned char c_input;
	FILE *page_preamble;
	FILE *input_file;
	FILE *output_file;
	int starting_page;
	long page_preamble_length;
	long byte;
	
	//Arguments:
	//File for First 256 bytes in "page"
	//Starting Page (integer)
	//Input File
	
	if(argc<4)
	{
		printf("Usage: <page_preamble_file> <starting_page> <file_to_fit>");
		exit(-1);
	}

	sscanf(argv[2], "%d", &starting_page);
	
	printf("Argument Count: %d\r\n", argc);
	printf("Preamble File: %s\r\n", argv[1]);
	printf("Starting Page: %d\r\n", starting_page);
	printf("Input Data File: %s\r\n", argv[3]);
	printf("---------------\r\n");
	
	//Open Preamble File
	if ((page_preamble = fopen(argv[1], "rb"))==NULL) {
		perror("preamble fopen failed!");
		printf("Exiting due to an error!\r\n");
		exit(-1);
	}
	
	//Get Preamble File Size
	fseek (page_preamble, 0, SEEK_END);
	page_preamble_length = ftell(page_preamble);
	rewind(page_preamble);
	
	printf("Preamble File Length: %d\r\n", page_preamble_length);
	
	//Allocate memory to contain the whole file:
	buffer = (char*)malloc(sizeof(char)*page_preamble_length);
	if(buffer == NULL)
	{
		printf("Memory error");
		exit (-1);
	}

	//Read entire file
	if(fread(buffer, 1, page_preamble_length, page_preamble) != page_preamble_length)
	{
		printf("Page Preamble Reading error");
		exit(-1);
	}

	//Close Preamble File
	if (fclose(page_preamble) != 0) {
		perror("preamble fclose failed!");
		printf("Exiting due to an error!\r\n");
		exit(-1);
	}

	//Open Input Data File
	if ((input_file = fopen(argv[3], "rb"))==NULL) {
		perror("input file fopen failed!");
		printf("Exiting due to an error!\r\n");
		exit(-1);
	}
	
	starting_page--;
	while(!feof(input_file))
	{
		byte = 0;
		//Open Output Data File
		starting_page++;
		sprintf(OutputFileName, "%d.bin", starting_page);
		printf("Creating file %s\r\n", OutputFileName);
		if ((output_file = fopen(OutputFileName, "wb"))==NULL)
		{
			perror("input file fopen failed!");
			printf("Exiting due to an error!\r\n");
			exit(-1);
		}
		if(fwrite(buffer, 1, page_preamble_length, output_file) != page_preamble_length)
		{
			printf("writing preamble to output failed!");
			exit(-1);
		}
		byte = byte + page_preamble_length;
		c_input = fgetc(input_file);
		while(!feof(input_file) & byte<16384)
		{
			fputc(c_input, output_file);
			c_input = fgetc(input_file);
			byte++;
		}
		if(byte<16384)
		{
			while(byte<16384)
			{
				fputc(0, output_file);
				byte++;
			}
		}
		else
		{
			fseek(input_file, -2, SEEK_CUR);
		}
		//Close Output File
		if (fclose(output_file) != 0) {
			perror("output fclose failed!");
			printf("Exiting due to an error!\r\n");
			exit(-1);
		}
		
		c_input = fgetc(input_file);
	}
	if (fclose(input_file) != 0) {
		perror("input fclose failed!");
		printf("Exiting due to an error!\r\n");
		exit(-1);
	}

	return 0;
}
